<template lang="pug">
q-card(style="min-width: 20rem")
  q-card-section.q-pb-none
    .text-h6 {{ title }}
  q-card-section
    q-form(@submit="onSave")
      q-input.q-mb-sm(
        filled,
        label="Name",
        v-model="editingMessage.name",
        :rules="[(val) => (val && val.length) || 'Name cannot be empty']"
      )
      q-input(
        filled,
        type="textarea",
        label="Content",
        v-model="editingMessage.content",
        :rules="[(val) => (val && val.length) || 'Content cannot be empty']"
      )
      .text-h6.q-mt-md Timing
      q-separator(spaced)
      q-select(
        label="From",
        :rules="[(val) => (val && val.length) || 'From cannot be empty']",
        :options="['manual', 'start', 'end']",
        v-model="editingMessage.config.from"
      )
      q-input(
        v-if="editingMessage.config.from !== 'manual'",
        :label="`Time (from section ${editingMessage.config.from})`",
        :rules="[(val) => (val && val.length) || 'Time cannot be empty', validTime]",
        v-model="editingMessage.config.time"
      )
      .text-h6.q-mt-md Type
      q-separator(spaced)
      q-select(
        label="Type",
        :options="['broadcast', 'sensor']",
        :rules="[(val) => (val && val.length) || 'Type cannot be empty']",
        v-model="editingMessage.config.type"
      )
      q-select(
        v-if="editingMessage.config.type === 'sensor'",
        label="Sensors (comma-separated)",
        :options="zoomSensors",
        v-model="editingMessage.config.sensors"
      )
      .row.q-mt-md
        q-space
        q-btn.q-mr-sm(label="Cancel", @click="cancel", :disabled="loading")
        q-btn(type="submit", label="Save", color="primary", :loading="loading")
</template>

<script>
import humanInterval from "human-interval";

// If the `message` prop isn't passed (or is passed as undefined), this is effectively
// a NewMessage component. i.e. this component can be used to edit existing messages, or
// for creating new messages
export default {
  props: {
    message: { required: false },
    cancel: { required: true },
    save: { required: true },
    zoomSensors: { required: true },
  },
  data() {
    return { editingMessage: {}, loading: false };
  },
  created() {
    if (this.message) {
      // Deep copy of message
      this.editingMessage = JSON.parse(JSON.stringify(this.message));
    } else {
      this.editingMessage = {
        name: undefined,
        content: undefined,
        config: {
          from: "end",
          type: undefined,
        },
      };
    }
  },
  computed: {
    title() {
      if (this.message) {
        return "Editing Message";
      }
      return "New Message";
    },
  },
  methods: {
    async onSave() {
      this.loading = true;
      await this.save(this.editingMessage);
      this.loading = false;
    },
    validTime(value) {
      const res = humanInterval(value);
      return (res && res > 0) || "Invalid time";
    },
  },
};
</script>
